#ifndef _TVP_PLUGIN_OS_VERSION_H_
#define _TVP_PLUGIN_OS_VERSION_H_

#include "TVPPlugIn.h"


// QlF
// http://yokohama.cool.ne.jp/chokuto/advanced/version.html


/*
typedef struct _OSVERSIONINFO {
    DWORD dwOSVersionInfoSize;  // structure size
    DWORD dwMajorVersion;       // major version
    DWORD dwMinorVersion;       // minor version
    DWORD dwBuildNumber;        // build number
    DWORD dwPlatformId;         // platform ID
    TCHAR szCSDVersion[128];    // additional information
} OSVERSIONINFO, *POSVERSIONINFO, *LPOSVERSIONINFO;

typedef struct _OSVERSIONINFO {
    DWORD dwOSVersionInfoSize;  // structure size
    DWORD dwMajorVersion;       // major version
    DWORD dwMinorVersion;       // minor version
    DWORD dwBuildNumber;        // build number
    DWORD dwPlatformId;         // platform ID
    TCHAR szCSDVersion[128];    // additional string
    WORD  wServicePackMajor;    // SP major version
    WORD  wServicePackMinor;    // SP minor version
    WORD  wSuiteMask;           // product suites
    BYTE  wProductType;         // additional information
    BYTE  wReserved;            // reserved
} OSVERSIONINFOEX, *POSVERSIONINFOEX, *LPOSVERSIONINFOEX;
*/



// OSo[W
struct OSVersionInfo
{
public:
	OSVERSIONINFO   info;
	OSVERSIONINFOEX infoEx;

	/*
	 0: LbV
	 1: OSVERSIONINFO
	 2: OSVERSIONINFOEX
	*/
	tjs_int cacheLevel;

	OSVersionInfo()
	{
		cacheLevel = 0;
	}

	virtual tjs_int getInfo()
	{
		// LbVĂ牽Ȃ
		if (cacheLevel <= 0) {
			info.dwOSVersionInfoSize   = sizeof(OSVERSIONINFO);
			infoEx.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

			if (GetVersionExA(&info)) {
				cacheLevel = 1;

				if (GetVersionExA((OSVERSIONINFO *)(&infoEx))) {
					cacheLevel = 2;
				}
			}
		}

		return cacheLevel;
	}

};

#endif _TVP_PLUGIN_OS_VERSION_H_
