#ifndef _TVP_PLUGIN_PAINT_FUNC_H_
#define _TVP_PLUGIN_PAINT_FUNC_H_

#include "TVPPlugIn.h"

// yCg
#define TP_PAINT_REF_ALPHA    1
#define TP_PAINT_REF_MASK     2
#define TP_PAINT_REF_OPAQUE   3
#define TP_PAINT_REF_PROVINCE 4




// yCgp
struct SeedFillInfo {
public:
	int lx;	// ̈捶[XW
	int rx;	// ̈E[XW
	int y;	// ̈YW
	int oy;	// eCYW
};

// yCgp
struct SeedFillBuffer {
private:
	tjs_int numInfo;

protected:
	int idxStart;
	int idxEnd;
	LayerInfo * layer;
	tjs_uint8 * drawnBuffer;

public:
	SeedFillInfo ** info;

	SeedFillBuffer(tjs_int n, LayerInfo * layer);

	virtual ~SeedFillBuffer();

	inline tjs_int count() { return numInfo; }

	inline SeedFillInfo * start() { return info[idxStart]; }
	inline SeedFillInfo * end()   { return info[idxEnd]; }

	inline SeedFillInfo * resetStart() { return info[idxStart = 0]; }
	inline SeedFillInfo * resetEnd()   { return info[idxEnd = 0]; }

	bool incStart();
	bool incEnd();

	// ͈̓`FbNȂ[
	bool isDrawn(tjs_int x, tjs_int y) const;

	// ͈̓`FbNȂ[
	void setDrawn(tjs_int x, tjs_int y, tjs_int w);

};



// yCg
tjs_int TPFUNCCALL Layer_paintImpl(
	LayerInfo * layer,
	LayerInfo * pvLayer,
	tjs_int x,
	tjs_int y,
	tjs_uint32 paint_color,
	tjs_int opa,
	tjs_int ref);	// QƂ`



#endif _TVP_PLUGIN_PAINT_FUNC_H_

