#include "GraphFunc.h"
#include "TPGraphic.h"
#include "LayerBufferImpl.h"

//#include <math.h>

// XVtO
extern bool TPFAutoUpdateMode;



//	const tTVPRect * const draw = info->drawRect;


// `
/*
n_ƏI_XWȂAcƂ݂ȂďB
n_ƏI_YWȂAƂ݂ȂďB
ǂłȂΎΐƂďiDDAŁjB
*/
tjs_int TPFUNCCALL Layer_drawLineImpl(
	LayerInfo * layer,
	tjs_int x1,
	tjs_int y1,
	tjs_int x2,
	tjs_int y2,
	tjs_uint32 col,
	tjs_int opa)
{
	tjs_int rv = 0;

	// c
	if (x1 == x2) {
		tjs_int sy = (y1 < y2) ? y1 : y2;
		tjs_int dy = (y1 < y2) ? y2 - y1 : y1 - y2; // Y̕-1
		rv = Layer_drawVerticalLineImpl(layer, x1, sy, dy + 1, col, opa);

		// auto update
		if (TPFAutoUpdateMode && rv) {
			Layer_FuncCall_update(layer, x1, sy, 1, dy+1);
		}

	// 
	} else if (y1 == y2) {
		tjs_int sx = (x1 < x2) ? x1 : x2;
		tjs_int dx = (x1 < x2) ? x2 - x1 : x1 - x2; // X̕-1
		rv = Layer_drawHorizontalLineImpl(layer, sx, y1, dx + 1, col, opa);

		// auto update
		if (TPFAutoUpdateMode && rv > 0) {
			Layer_FuncCall_update(layer, sx, y1, dx+1, 1);
		}

	// X
	} else {
		Layer_drawSlantLineImpl(layer, x1, y1, x2, y2, col, opa);

		// auto update
		if (TPFAutoUpdateMode && rv > 0) {
			tjs_int sx = (x1 < x2) ? x1 : x2;
			tjs_int sy = (y1 < y2) ? y1 : y2;
			tjs_int dx = (x1 < x2) ? x2 - x1 : x1 - x2; // X̕
			tjs_int dy = (y1 < y2) ? y2 - y1 : y1 - y2; // Y̕
			Layer_FuncCall_update(layer, sx, sy, dx+1, dy+1);
		}

	}

	return rv;
}



// ΐ`iŒ菬_j

/* BENCH:2005-03-25

DX=+300, DY=+300 ̒{̕`掞(ms)
Fill ARGB
TVP 0.02219
1px 0.02187

Alpha Blend
TVP 0.0375
1px 0.02922

AddAlpha Blend
TVP 0.03218
1px 0.0325
*/

tjs_int TPFUNCCALL Layer_drawSlantLineImpl(
	LayerInfo * layer,
	tjs_int x1,
	tjs_int y1,
	tjs_int x2,
	tjs_int y2,
	tjs_uint32 col,
	tjs_int opa)
{
	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	const tjs_int width = 1;
	const tjs_int face = layer->face;
	tjs_int rv = 0;

	const tjs_int dx = (x2 > x1) ? (x2 - x1) : (x1 - x2); // X̕
	const tjs_int dy = (y2 > y1) ? (y2 - y1) : (y1 - y2); // Y̕

	const bool isSteep = (dx < dy); // X1傫 true

	tjs_int stepx, stepy;
	tjs_int x = x1 << 16;
	tjs_int y = y1 << 16;
	const unsigned char * const OpaOpaTable = TVPOpacityOnOpacityTable;

	if (isSteep) {
		stepx = ((x2 - x1) << 16) / dy;
		stepy = (y2 > y1) ? (1 << 16) : (-1 << 16);
		x += 0x8000;
	} else {
		stepx = (x2 > x1) ? (1 << 16) : (-1 << 16);
		stepy = ((y2 - y1) << 16) / dx;
		y += 0x8000;
	}

// hbgł
// ijuBCC warning: W8060 : 炭sȑvȂłB
#define F__PSET_IMPL_P4A(func) if (tjs_uint32 * p = layer->getBufferPtr_StrictDraw(x >> 16, y >> 16)) { func (p, width, col, opa); rv++; }
#define F__PSET_IMPL_P3(func)  if (tjs_uint32 * p = layer->getBufferPtr_StrictDraw(x >> 16, y >> 16)) { func (p, col, opa); rv++; }
#define F__PSET_IMPL_P3T(func) if (tjs_uint32 * p = layer->getBufferPtr_StrictDraw(x >> 16, y >> 16)) { func (p, col, opa, OpaOpaTable); rv++; }
#define F__PSET_IMPL_P2(func)  if (tjs_uint32 * p = layer->getBufferPtr_StrictDraw(x >> 16, y >> 16)) { func (p, col); rv++; }
#define F__COND_IMPL x += stepx; y += stepy;
#define ITERATE_X for (tjs_int i = 0; i <= dx; i++)
#define ITERATE_Y for (tjs_int i = 0; i <= dy; i++)

	switch (face) {
	case dfAlpha: // main and mask ( == dfBoth )
		if (withOpa) {
			// X1傫ꍇ
			if (isSteep) {
				ITERATE_Y {
					F__PSET_IMPL_P3T(TVPPlugInConstColorAlphaBlend_d_1px);
					F__COND_IMPL
				}
			// X1ȉ̏ꍇ
			} else {
				ITERATE_X {
					F__PSET_IMPL_P3T(TVPPlugInConstColorAlphaBlend_d_1px);
					F__COND_IMPL
				}
			}
		} else {
			col |= 0xFF000000;
			if (isSteep) {
				ITERATE_Y {
					F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
					F__COND_IMPL
				}
			} else {
				ITERATE_X {
					F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
					F__COND_IMPL
				}
			}
		}
		// sx(RemoveConstOpacity)ɂ͖Ή
		break;

	case dfAddAlpha: // additive alpha; main and mask

		if (withOpa) {
			// addalpháAC TVPPlugIn***_1px() 
			// MMX TVP***() ̕킸ɑH
			if (isSteep) {
				ITERATE_Y {
					F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_a_1px);
					F__COND_IMPL
				}
			} else {
				ITERATE_X {
					F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_a_1px);
					F__COND_IMPL
				}
			}
		} else {
			col |= 0xFF000000;
			if (isSteep) {
				ITERATE_Y {
					F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
					F__COND_IMPL
				}
			} else {
				ITERATE_X {
					F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
					F__COND_IMPL
				}
			}
		}
		break;

	case dfOpaque: // main only
		if (withOpa) {
			if (isSteep) {
				ITERATE_Y {
					F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_1px);
					F__COND_IMPL
				}
			} else {
				ITERATE_X {
					F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_1px);
					F__COND_IMPL
				}
			}
		} else {
			col |= 0xFF000000;
			if (isSteep) {
				ITERATE_Y {
					F__PSET_IMPL_P2(TVPPlugInFillColor_1px);
					F__COND_IMPL
				}
			} else {
				ITERATE_X {
					F__PSET_IMPL_P2(TVPPlugInFillColor_1px);
					F__COND_IMPL
				}
			}
		}
		break;

	case dfMask: // mask ( opacity will be ignored )
		if (isSteep) {
			ITERATE_Y {
				F__PSET_IMPL_P2(TVPPlugInFillMask_1px);
				F__COND_IMPL
			}
		} else {
			ITERATE_X {
				F__PSET_IMPL_P2(TVPPlugInFillMask_1px);
				F__COND_IMPL
			}
		}
		break;

	case dfProvince: // province ( opacity will be ignored )
	default:
		// Ă܂
		rv = -1;
		break;

	}

#undef ITERATE_X
#undef ITERATE_Y
#undef F__PSET_IMPL_P2
#undef F__PSET_IMPL_P3
#undef F__PSET_IMPL_P3T
#undef F__PSET_IMPL_P4A
#undef F__COND_IMPL

	return rv;
}



// `
tjs_int TPFUNCCALL Layer_drawVerticalLineImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int h,
	tjs_uint32 col,
	tjs_int opa)
{
	const tTVPRect * const draw = layer->drawRect;

	if (
		(h < 0) ||
		(y > draw->bottom) ||
		(y + h < draw->top) ||
		(x < draw->left) ||
		(x > draw->right) ||
		(opa ==  0)
	) return 0;

	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	tjs_int y2 = y + h - 1;

	// K
	if (y  <  draw->top)    y  = draw->top;
	if (y2 >  draw->bottom) y2 = draw->bottom;

	tjs_uint32 * p = layer->getBufferPtr(x, y);
	tjs_int pitch = layer->bufferpitch / sizeof(tjs_uint32);
	const tjs_int width = 1;
	const tjs_int face = layer->face;
	const unsigned char * const OpaOpaTable = TVPOpacityOnOpacityTable;


#define ITERATE_Y for (tjs_int py = y; py <= y2; py++)
// `
// ijuBCC warning: W8060 : 炭sȑvȂłB
#define F__ITERATE_Y_VERTICAL_LINE_IMPL_P3(func) \
	ITERATE_Y { \
		func (p, col, opa); p += pitch; rv++; \
	}

#define F__ITERATE_Y_VERTICAL_LINE_IMPL_P3T(func) \
	ITERATE_Y { \
		func (p, col, opa, OpaOpaTable); p += pitch; rv++; \
	}

#define F__ITERATE_Y_VERTICAL_LINE_IMPL_P2(func) \
	ITERATE_Y { \
		func (p, col); p += pitch; rv++; \
	}

	switch (face) {
	case dfAlpha: // main and mask ( == dfBoth )
		if (withOpa) {
			F__ITERATE_Y_VERTICAL_LINE_IMPL_P3T(TVPPlugInConstColorAlphaBlend_d_1px);
		} else {
			col |= 0xFF000000;
			F__ITERATE_Y_VERTICAL_LINE_IMPL_P2(TVPPlugInFillARGB_1px);
		}
		// sx(RemoveConstOpacity)ɂ͖Ή
		break;

	case dfAddAlpha: // additive alpha; main and mask
		if (withOpa) {
			F__ITERATE_Y_VERTICAL_LINE_IMPL_P3(TVPPlugInConstColorAlphaBlend_a_1px);
		} else {
			col |= 0xFF000000;
			F__ITERATE_Y_VERTICAL_LINE_IMPL_P2(TVPPlugInFillARGB_1px);
		}
		break;

	case dfOpaque: // main only
		if (withOpa) {
			F__ITERATE_Y_VERTICAL_LINE_IMPL_P3(TVPPlugInConstColorAlphaBlend_1px);
		} else {
			col |= 0xFF000000;
			F__ITERATE_Y_VERTICAL_LINE_IMPL_P2(TVPPlugInFillColor_1px);
		}
		break;

	case dfMask: // mask ( opacity will be ignored )
		F__ITERATE_Y_VERTICAL_LINE_IMPL_P2(TVPPlugInFillMask_1px);
		break;

	case dfProvince: // province ( opacity will be ignored )
	default:
		// Ă܂
		rv = -1;
		break;

	}

#undef ITERATE_Y
#undef F__ITERATE_Y_VERTICAL_LINE_IMPL_P2
#undef F__ITERATE_Y_VERTICAL_LINE_IMPL_P3
#undef F__ITERATE_Y_VERTICAL_LINE_IMPL_P3T

	return rv;
}


// `
// Ă΂c
tjs_int TPFUNCCALL Layer_drawHorizontalLineImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_uint32 col,
	tjs_int opa)
{
	const tTVPRect * const draw = layer->drawRect;

	// no action
	if (
		(w <= 0) ||
		(x > draw->right) ||
		(x + w < draw->left) ||
		(y <  draw->top) ||
		(y > draw->bottom) ||
		(opa ==  0)
	) return 0;

	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	tjs_int x2 = x + w - 1;
	// K
	if (x  <  draw->left)  x  = draw->left;
	if (x2 >= draw->right) x2 = draw->right;
	tjs_int width = x2 - x + 1;

	tjs_uint32 * p = layer->getBufferPtr(x, y);
	const tjs_int face = layer->face;

	switch (face) {
	case dfAlpha: // main and mask ( == dfBoth )
		if (withOpa) {
			TVPConstColorAlphaBlend_d(p, width, col, opa);
		} else {
			col |= 0xFF000000;
			TVPFillARGB(p, width, col);
		}
		rv = width;
		// sx(RemoveConstOpacity)ɂ͖Ή
		break;

	case dfAddAlpha: // additive alpha; main and mask
		if (withOpa) {
			TVPConstColorAlphaBlend_a(p, width, col, opa);
		} else {
			col |= 0xFF000000;
			TVPFillARGB(p, width, col);
		}
		rv = width;
		break;

	case dfOpaque: // main only
		if (withOpa) {
			TVPConstColorAlphaBlend(p, width, col, opa);
		} else {
			col |= 0xFF000000;
			TVPFillColor(p, width, col);
		}
		rv = width;
		break;

	case dfMask: // mask ( opacity will be ignored )
		TVPFillMask(p, width, opa);
		rv = width;
		break;

	case dfProvince: // province ( opacity will be ignored )
	default:
		// Ă܂
		rv = -1;
		break;

	}

	return rv;
}



// Rs[`
// Ă΂c
tjs_int TPFUNCCALL Layer_copyHorizontalLineImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_uint32 * src,
	tjs_int opa)
{
	const tTVPRect * const draw = layer->drawRect;

	// no action
	if (
		(w <= 0) ||
		(x > draw->right) ||
		(x + w < draw->left) ||
		(y <  draw->top) ||
		(y > draw->bottom) ||
		(opa ==  0)
	) return 0;

	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	tjs_int x2 = x + w - 1;
	// K
	if (x  <  draw->left) {
		//Jnʒu炷
		src += draw->left - x;
		x  = draw->left;
	}
	if (x2 >= draw->right) x2 = draw->right;
	tjs_int width = x2 - x + 1;

	tjs_uint32 * p = layer->getBufferPtr(x, y);
	const tjs_int face = layer->face;

	switch (face) {
	case dfAlpha: // main and mask ( == dfBoth )
		if (withOpa) {
			TVPConstAlphaBlend_d(p, src, width, opa);
		} else {
			TVPPlugInCopyARGB(p, src, width);
		}
		rv = width;
		// sx(RemoveConstOpacity)ɂ͖Ή
		break;

	case dfAddAlpha: // additive alpha; main and mask
		if (withOpa) {
			TVPConstAlphaBlend_a(p, src, width, opa);
		} else {
			TVPPlugInCopyARGB(p, src, width);
		}
		rv = width;
		break;

	case dfOpaque: // main only
		if (withOpa) {
			TVPConstAlphaBlend(p, src, width, opa);
		} else {
			TVPCopyColor(p, src, width);
		}
		rv = width;
		break;

	case dfMask: // mask ( opacity will be ignored )
		TVPCopyMask(p, src, width);
		rv = width;
		break;

	case dfProvince: // province ( opacity will be ignored )
	default:
		// Ă܂
		rv = -1;
		break;

	}

	return rv;
}






// ~b`Fi[
#define F__MICHENER_COND_IMPL \
	dy++; \
	E += 4 * dy + 2; \
	if ( E >= 0 ) { \
		dx--; \
		E -= 4 * dx; \
	}


// ~`
/*
C犮Sɂ͂ݏoĂ珈svB
~b`Fi[̃ASYŕ`B

*/
tjs_int TPFUNCCALL Layer_drawCircleImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa)
{
	// `sv
	if ((r <= 0) || 
		(x - r > layer->width) ||
		(y - r > layer->height) ||
		(x + r < 0) ||
		(y + r < 0)) 
		return 0;

	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	const tjs_int width = 1;
	const tjs_int face = layer->face;
	const tTVPRect * const draw = layer->drawRect;
	const unsigned char * const OpaOpaTable = TVPOpacityOnOpacityTable;

	tjs_int dx = r;
	tjs_int dy = 0;
	tjs_int E = -2 * r + 3;


// hbgł
// ijuBCC warning: W8060 : 炭sȑvȂłB
#define F__PSET_IMPL_P2_EACH(_x, _y, _func)  if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col); rv++; }
#define F__PSET_IMPL_P3_EACH(_x, _y, _func)  if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col, opa); rv++; }
#define F__PSET_IMPL_P3T_EACH(_x, _y, _func) if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col, opa, OpaOpaTable); rv++; }

// ֐̈3
#define F__PSET_IMPL_P3(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P3_EACH(x + dx, y + dy, _func) \
	F__PSET_IMPL_P3_EACH(x - dx, y + dy, _func) \
	F__PSET_IMPL_P3_EACH(x + dx, y - dy, _func) \
	F__PSET_IMPL_P3_EACH(x - dx, y - dy, _func) \
	F__PSET_IMPL_P3_EACH(x + dy, y + dx, _func) \
	F__PSET_IMPL_P3_EACH(x - dy, y + dx, _func) \
	F__PSET_IMPL_P3_EACH(x + dy, y - dx, _func) \
	F__PSET_IMPL_P3_EACH(x - dy, y - dx, _func) \
}

#define F__PSET_IMPL_P3T(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P3T_EACH(x + dx, y + dy, _func) \
	F__PSET_IMPL_P3T_EACH(x - dx, y + dy, _func) \
	F__PSET_IMPL_P3T_EACH(x + dx, y - dy, _func) \
	F__PSET_IMPL_P3T_EACH(x - dx, y - dy, _func) \
	F__PSET_IMPL_P3T_EACH(x + dy, y + dx, _func) \
	F__PSET_IMPL_P3T_EACH(x - dy, y + dx, _func) \
	F__PSET_IMPL_P3T_EACH(x + dy, y - dx, _func) \
	F__PSET_IMPL_P3T_EACH(x - dy, y - dx, _func) \
}

// ֐̈2
#define F__PSET_IMPL_P2(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P2_EACH(x + dx, y + dy, _func) \
	F__PSET_IMPL_P2_EACH(x - dx, y + dy, _func) \
	F__PSET_IMPL_P2_EACH(x + dx, y - dy, _func) \
	F__PSET_IMPL_P2_EACH(x - dx, y - dy, _func) \
	F__PSET_IMPL_P2_EACH(x + dy, y + dx, _func) \
	F__PSET_IMPL_P2_EACH(x - dy, y + dx, _func) \
	F__PSET_IMPL_P2_EACH(x + dy, y - dx, _func) \
	F__PSET_IMPL_P2_EACH(x - dy, y - dx, _func) \
}

	switch (face) {
	case dfAlpha: // main and mask ( == dfBoth )
		if (withOpa) {
			while (dx >= dy) {
				F__PSET_IMPL_P3T(TVPPlugInConstColorAlphaBlend_d_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= dy) {
				F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
				F__MICHENER_COND_IMPL
			}
		}
		// sx(RemoveConstOpacity)ɂ͖Ή
		break;

	case dfAddAlpha: // additive alpha; main and mask
		if (withOpa) {
			while (dx >= dy) {
				F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_a_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= dy) {
				F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
				F__MICHENER_COND_IMPL
			}
		}
		break;

	case dfOpaque: // main only
		if (withOpa) {
			while (dx >= dy) {
				F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= dy) {
				F__PSET_IMPL_P2(TVPPlugInFillColor_1px);
				F__MICHENER_COND_IMPL
			}
		}
		break;

	case dfMask: // mask ( opacity will be ignored )
		while (dx >= dy) {
			F__PSET_IMPL_P2(TVPPlugInFillMask_1px);
			F__MICHENER_COND_IMPL
		}
		break;

	case dfProvince: // province ( opacity will be ignored )
	default:
		// Ă܂
		rv = -1;
		break;
	}

#undef F__PSET_IMPL_P2
#undef F__PSET_IMPL_P3
#undef F__PSET_IMPL_P3T
#undef F__PSET_IMPL_P2_EACH
#undef F__PSET_IMPL_P3_EACH
#undef F__PSET_IMPL_P3T_EACH

	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		Layer_FuncCall_update(layer, x-r, y-r, 2*r+1, 2*r+1);
	}

	return rv;
}



// hԂ~`
/*
C犮Sɂ͂ݏoĂ珈svB
~b`Fi[̃ASYőȂ琅œhԂĂB

*/
tjs_int TPFUNCCALL Layer_drawFillCircleImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa)
{
	// `sv
	if ((r <= 0) || 
		(x - r > layer->width) ||
		(y - r > layer->height) ||
		(x + r < 0) ||
		(y + r < 0)) 
		return 0;

	// K
	REG_OPA(opa);

	tjs_int rv = 0;

	tjs_int dx = r;
	tjs_int dy = 1;
	tjs_int prevdx = dy-1;
	tjs_int E = -2 * r + 3;


	//S
	tjs_int trv = Layer_drawHorizontalLineImpl(layer, x - r, y, r * 2 + 1, col, opa);
	F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv)

	while (dx >= dy) {
		tjs_int trv;
		trv = Layer_drawHorizontalLineImpl(layer, x - dx, y + dy, dx * 2 + 1, col, opa);
		F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		trv = Layer_drawHorizontalLineImpl(layer, x - dx, y - dy, dx * 2 + 1, col, opa);
		F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		//xh~
		if (prevdx != dx && dx != dy) {
			trv = Layer_drawHorizontalLineImpl(layer, x - dy, y + dx, dy * 2 + 1, col, opa);
			F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
			trv = Layer_drawHorizontalLineImpl(layer, x - dy, y - dx, dy * 2 + 1, col, opa);
			F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		}

		prevdx = dx;
		F__MICHENER_COND_IMPL
	}

	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		Layer_FuncCall_update(layer, x-r, y-r, 2*r+1, 2*r+1);
	}

	return rv;
}





// pۂ``
/*
C犮Sɂ͂ݏoĂ珈svB
1. p`B

	   PPPP  
	b          b
	b          b
	   QQQQ  

2. ~`v̂Ŋۊp`B

	 ^PPPP_
	b          b
	b          b
	 _QQQQ^

*/
tjs_int TPFUNCCALL Layer_drawRoundRectImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa)
{
	// sv
	if ((w <= 0) || (h <= 0) || 
		(x + w < 0) ||(y + h < 0) ||
		(x >= layer->width) || (y >= layer->height))
		return 0;

	r = (r > 0) ? r : 0;
	r = (r > w/2) ? w/2 : r;
	r = (r > h/2) ? h/2 : r;

	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	// p`
#define F__CHECK_HL_IMPL_RESULT(_trv, _rv) \
	if (trv >= 0) { \
		_rv += _trv; \
	} else { \
		_rv = _trv; \
		return break; \
	}

	tjs_int trv;
	trv = Layer_drawHorizontalLineImpl(layer, x + r, y        , w - 2 * r, col, opa);
	F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv)
	trv = Layer_drawHorizontalLineImpl(layer, x + r, y + h - 1, w - 2 * r, col, opa);
	F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv)
	trv = Layer_drawVerticalLineImpl  (layer, x        , y + r, h - 2 * r, col, opa);
	F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv)
	trv = Layer_drawVerticalLineImpl  (layer, x + w - 1, y + r, h - 2 * r, col, opa);
	F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv)

	// pۂ߂
	const tjs_int width = 1;
	const tjs_int face = layer->face;
	const tTVPRect * const draw = layer->drawRect;
	const unsigned char * const OpaOpaTable = TVPOpacityOnOpacityTable;

	tjs_int dx = r;
	tjs_int dy = 0;
	tjs_int E = -2 * r + 3;
	tjs_int w2 = w - 1 - r;
	tjs_int h2 = h - 1 - r;

// hbgł
// ijuBCC warning: W8060 : 炭sȑvȂłB
#define F__PSET_IMPL_P2_EACH(_x, _y, _func)  if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col); rv++; }
#define F__PSET_IMPL_P3_EACH(_x, _y, _func)  if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col, opa); rv++; }
#define F__PSET_IMPL_P3T_EACH(_x, _y, _func) if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col, opa, OpaOpaTable); rv++; }


// ֐̈3
#define F__PSET_IMPL_P3(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P3_EACH(x + dx + w2, y + dy + h2, _func) \
	F__PSET_IMPL_P3_EACH(x - dx + r , y + dy + h2, _func) \
	F__PSET_IMPL_P3_EACH(x + dx + w2, y - dy + r , _func) \
	F__PSET_IMPL_P3_EACH(x - dx + r , y - dy + r , _func) \
	F__PSET_IMPL_P3_EACH(x + dy + w2, y + dx + h2, _func) \
	F__PSET_IMPL_P3_EACH(x - dy + r , y + dx + h2, _func) \
	F__PSET_IMPL_P3_EACH(x + dy + w2, y - dx + r , _func) \
	F__PSET_IMPL_P3_EACH(x - dy + r , y - dx + r , _func) \
}

// ֐̈3
#define F__PSET_IMPL_P3T(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P3T_EACH(x + dx + w2, y + dy + h2, _func) \
	F__PSET_IMPL_P3T_EACH(x - dx + r , y + dy + h2, _func) \
	F__PSET_IMPL_P3T_EACH(x + dx + w2, y - dy + r , _func) \
	F__PSET_IMPL_P3T_EACH(x - dx + r , y - dy + r , _func) \
	F__PSET_IMPL_P3T_EACH(x + dy + w2, y + dx + h2, _func) \
	F__PSET_IMPL_P3T_EACH(x - dy + r , y + dx + h2, _func) \
	F__PSET_IMPL_P3T_EACH(x + dy + w2, y - dx + r , _func) \
	F__PSET_IMPL_P3T_EACH(x - dy + r , y - dx + r , _func) \
}

// ֐̈2
#define F__PSET_IMPL_P2(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P2_EACH(x + dx + w2, y + dy + h2, _func) \
	F__PSET_IMPL_P2_EACH(x - dx + r , y + dy + h2, _func) \
	F__PSET_IMPL_P2_EACH(x + dx + w2, y - dy + r , _func) \
	F__PSET_IMPL_P2_EACH(x - dx + r , y - dy + r , _func) \
	F__PSET_IMPL_P2_EACH(x + dy + w2, y + dx + h2, _func) \
	F__PSET_IMPL_P2_EACH(x - dy + r , y + dx + h2, _func) \
	F__PSET_IMPL_P2_EACH(x + dy + w2, y - dx + r , _func) \
	F__PSET_IMPL_P2_EACH(x - dy + r , y - dx + r , _func) \
}

	// Layer_drawCircleImpl() ̂̂ƑSBRsyOKB
	switch (face) {
	case dfAlpha: // main and mask ( == dfBoth )
		if (withOpa) {
			while (dx >= dy) {
				F__PSET_IMPL_P3T(TVPPlugInConstColorAlphaBlend_d_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= dy) {
				F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
				F__MICHENER_COND_IMPL
			}
		}
		// sx(RemoveConstOpacity)ɂ͖Ή
		break;

	case dfAddAlpha: // additive alpha; main and mask
		if (withOpa) {
			while (dx >= dy) {
				F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_a_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= dy) {
				F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
				F__MICHENER_COND_IMPL
			}
		}
		break;

	case dfOpaque: // main only
		if (withOpa) {
			while (dx >= dy) {
				F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= dy) {
				F__PSET_IMPL_P2(TVPPlugInFillColor_1px);
				F__MICHENER_COND_IMPL
			}
		}
		break;

	case dfMask: // mask ( opacity will be ignored )
		while (dx >= dy) {
			F__PSET_IMPL_P2(TVPPlugInFillMask_1px);
			F__MICHENER_COND_IMPL
		}
		break;

	case dfProvince: // province ( opacity will be ignored )
	default:
		// Ă܂
		rv = -1;
		break;
	}

#undef F__PSET_IMPL_P2
#undef F__PSET_IMPL_P3
#undef F__PSET_IMPL_P3T
#undef F__PSET_IMPL_P2_EACH
#undef F__PSET_IMPL_P3_EACH
#undef F__PSET_IMPL_P3T_EACH

	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		Layer_FuncCall_update(layer, x, y, w, h);
	}

	return rv;
}




// hԂꂽpۂ``
/*
C犮Sɂ͂ݏoĂ珈svB
1.㉺``B


	bb
	bb


2. hԂ~`v̂ŏ㉺`B

	 ^_
	bb
	bb
	 _^

*/

tjs_int TPFUNCCALL Layer_drawFillRoundRectImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa)
{
	// sv
	if ((w <= 0) || (h <= 0) || 
		(x + w < 0) ||(y + h < 0) ||
		(x >= layer->width) || (y >= layer->height))
		return 0;

	// K
	REG_OPA(opa);

	tjs_int rv = 0;

	r = (r > 0) ? r : 0;
	r = (r > w/2) ? w/2 : r;
	r = (r > h/2) ? h/2 : r;

	// ㉺`
	for (tjs_int py = y + r; py < y + h - r; py++) {
		tjs_int trv = Layer_drawHorizontalLineImpl(layer, x, py, w, col, opa);
		F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv)
	}

	// pۂ߂
	tjs_int dx = r;
	tjs_int dy = 1;
	tjs_int prevdx = dy-1;
	tjs_int E = -2 * r + 3;

	while (dx >= dy) {
		tjs_int trv;
		trv = Layer_drawHorizontalLineImpl(layer, x + r - dx, y + h - r + dy - 1, w - (r - dx) * 2, col, opa);
		F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		trv = Layer_drawHorizontalLineImpl(layer, x + r - dx, y     + r - dy    , w - (r - dx) * 2, col, opa);
		F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		//Qxh~
		if (prevdx != dx && dx != dy) {
			trv = Layer_drawHorizontalLineImpl(layer, x + r - dy, y + h - r + dx - 1, w - (r - dy) * 2, col, opa);
			F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
			trv = Layer_drawHorizontalLineImpl(layer, x + r - dy, y     + r - dx    , w - (r - dy) * 2, col, opa);
			F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		}

		prevdx = dx;
		F__MICHENER_COND_IMPL
	}

	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		Layer_FuncCall_update(layer, x, y, w, h);
	}

	return rv;
}

#undef F__MICHENER_COND_IMPL




// ȉ~p~b`Fi[iHj
// [Asigned 32bit Ⴋc
#define F__MICHENER_COND_IMPL \
	if (F < 0) {	\
		dy++;	\
		F += ra2x2 * (2 * dy + 1);	\
		H += ra2x4 * dy;	\
	} else if (H >= 0) {	\
		dx--;	\
		F -= rb2x4 * dx;	\
		H -= rb2x2 * (2 * dx - 1);	\
	} else {	\
		dx--;	\
		dy++;	\
		F += ra2x2 * ( 2 * dy + 1) - rb2x4 * dx;	\
		H += rb2x2 * (-2 * dx + 1) + ra2x4 * dy;	\
	}


/*
ȉ~`
IWiR[hF
	http://www2.starcat.ne.jp/~fussy/algo/algo2-2.htm

C犮Sɂ͂ݏoĂ珈svB
*/
tjs_int TPFUNCCALL Layer_drawEllipseImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int ra,
	tjs_int rb,
	tjs_uint32 col,
	tjs_int opa)
{
	// `sv
	if ((ra <= 0) || 
		(rb <= 0) || 
		(x - ra > layer->width) ||
		(y - rb > layer->height) ||
		(x + ra < 0) ||
		(y + rb < 0)) 
		return 0;

	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	const tjs_int width = 1;
	const tjs_int face = layer->face;
	const tTVPRect * const draw = layer->drawRect;
	const unsigned char * const OpaOpaTable = TVPOpacityOnOpacityTable;

	const tjs_int ra2x2 = ra * ra * 2;
	const tjs_int rb2x2 = rb * rb * 2;
	const tjs_int ra2x4 = ra * ra * 4;
	const tjs_int rb2x4 = rb * rb * 4;

	tjs_int dx = ra;
	tjs_int dy = 0;
	tjs_int F = (-2 * ra + 1) * rb * rb + ra2x2;
	tjs_int H = (-4 * ra + 2) * rb + (ra * ra);

// hbgł
// ijuBCC warning: W8060 : 炭sȑvȂłB
#define F__PSET_IMPL_P2_EACH(_x, _y, _func)  if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col); rv++; }
#define F__PSET_IMPL_P3_EACH(_x, _y, _func)  if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col, opa); rv++; }
#define F__PSET_IMPL_P3T_EACH(_x, _y, _func) if (p = layer->getBufferPtr_StrictDraw(_x,  _y)) { _func (p, col, opa, OpaOpaTable); rv++; }

// ֐̈3
#define F__PSET_IMPL_P3(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P3_EACH(x + dx, y + dy, _func) \
	F__PSET_IMPL_P3_EACH(x - dx, y + dy, _func) \
	F__PSET_IMPL_P3_EACH(x + dx, y - dy, _func) \
	F__PSET_IMPL_P3_EACH(x - dx, y - dy, _func) \
}

// ֐̈3
#define F__PSET_IMPL_P3T(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P3T_EACH(x + dx, y + dy, _func) \
	F__PSET_IMPL_P3T_EACH(x - dx, y + dy, _func) \
	F__PSET_IMPL_P3T_EACH(x + dx, y - dy, _func) \
	F__PSET_IMPL_P3T_EACH(x - dx, y - dy, _func) \
}

// ֐̈2
#define F__PSET_IMPL_P2(_func) { \
	tjs_uint32 * p; \
	F__PSET_IMPL_P2_EACH(x + dx, y + dy, _func) \
	F__PSET_IMPL_P2_EACH(x - dx, y + dy, _func) \
	F__PSET_IMPL_P2_EACH(x + dx, y - dy, _func) \
	F__PSET_IMPL_P2_EACH(x - dx, y - dy, _func) \
}

	switch (face) {
	case dfAlpha: // main and mask ( == dfBoth )
		if (withOpa) {
			while (dx >= 0) {
				F__PSET_IMPL_P3T(TVPPlugInConstColorAlphaBlend_d_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= 0) {
				F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
				F__MICHENER_COND_IMPL
			}
		}
		// sx(RemoveConstOpacity)ɂ͖Ή
		break;

	case dfAddAlpha: // additive alpha; main and mask
		if (withOpa) {
			while (dx >= 0) {
				F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_a_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= 0) {
				F__PSET_IMPL_P2(TVPPlugInFillARGB_1px);
				F__MICHENER_COND_IMPL
			}
		}
		break;

	case dfOpaque: // main only
		if (withOpa) {
			while (dx >= 0) {
				F__PSET_IMPL_P3(TVPPlugInConstColorAlphaBlend_1px);
				F__MICHENER_COND_IMPL
			}
		} else {
			col |= 0xFF000000;
			while (dx >= 0) {
				F__PSET_IMPL_P2(TVPPlugInFillColor_1px);
				F__MICHENER_COND_IMPL
			}
		}
		break;

	case dfMask: // mask ( opacity will be ignored )
		while (dx >= 0) {
			F__PSET_IMPL_P2(TVPPlugInFillMask_1px);
			F__MICHENER_COND_IMPL
		}
		break;

	case dfProvince: // province ( opacity will be ignored )
	default:
		// Ă܂
		rv = -1;
		break;
	}

#undef F__PSET_IMPL_P2
#undef F__PSET_IMPL_P3
#undef F__PSET_IMPL_P3T
#undef F__PSET_IMPL_P2_EACH
#undef F__PSET_IMPL_P3_EACH
#undef F__PSET_IMPL_P3T_EACH

	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		Layer_FuncCall_update(layer, x-ra, y-rb, 2*ra+1, 2*rb+1);
	}

	return rv;
}


// ȉ~`ihԂj
/*
C犮Sɂ͂ݏoĂ珈svB
*/
tjs_int TPFUNCCALL Layer_drawFillEllipseImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int ra,
	tjs_int rb,
	tjs_uint32 col,
	tjs_int opa)
{
	// `sv
	if ((ra <= 0) || 
		(rb <= 0) || 
		(x - ra > layer->width) ||
		(y - rb > layer->height) ||
		(x + ra < 0) ||
		(y + rb < 0)) 
		return 0;

	// K
	REG_OPA(opa);

	const bool withOpa = (opa < 255);
	tjs_int rv = 0;

	const tjs_int face = layer->face;
	const tTVPRect * const draw = layer->drawRect;

	const tjs_int ra2x2 = ra * ra * 2;
	const tjs_int rb2x2 = rb * rb * 2;
	const tjs_int ra2x4 = ra * ra * 4;
	const tjs_int rb2x4 = rb * rb * 4;

	tjs_int dx = ra;
	tjs_int dy = 0;
	tjs_int F = (-2 * ra + 1) * rb * rb + ra2x2;
	tjs_int H = (-4 * ra + 2) * rb + (ra * ra);

	//S
	tjs_int trv = Layer_drawHorizontalLineImpl(layer, x - ra, y, ra * 2 + 1, col, opa);
	F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv)

	tjs_int prevdy = dy;
	F__MICHENER_COND_IMPL

	while (dx > 0) {
		if (dy != prevdy) {
			tjs_int trv;
			trv = Layer_drawHorizontalLineImpl(layer, x - dx, y + dy, dx * 2 + 1, col, opa);
			F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
			trv = Layer_drawHorizontalLineImpl(layer, x - dx, y - dy, dx * 2 + 1, col, opa);
			F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		}
		prevdy = dy;

		F__MICHENER_COND_IMPL
	}

	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		Layer_FuncCall_update(layer, x-ra, y-rb, 2*ra+1, 2*rb+1);
	}

	return rv;
}


#undef F__MICHENER_COND_IMPL




// hԂꂽOp``
/*
O_YŃ\[g P1(x1,y1) P2(x2,y2) P3(x3,y3)B
P2ʂ鐅ƐP1P3Ƃ̌_P2'ƂB

	      P1
	       /_
	      /   _
	 P2' /_______ P2
	    /       ^
	   /     ^
	  /   ^
	 / ^
	/^
	P3

XLȂOp`P1P2'P2hԂB
P1P2', P1P2 ̑DDAōsB

XLȂOp`P2'P2P3hԂB
P2'P3, P2P3 ̑DDAōsB

*/

tjs_int TPFUNCCALL Layer_drawFillTriangleImpl(
	LayerInfo * layer,
	tjs_int x1,
	tjs_int y1,
	tjs_int x2,
	tjs_int y2,
	tjs_int x3,
	tjs_int y3,
	tjs_uint32 col,
	tjs_int opa)
{

	// K
	REG_OPA(opa);

	tjs_int rv = 0;

	// sort y1 <= y2 <= y3
	/*sort*/{
		tjs_int tmp;
		if (y1 > y2) {
			SWAP_INT(y1, y2, tmp);
			SWAP_INT(x1, x2, tmp);
		}
		if (y1 > y3) {
			SWAP_INT(y1, y3, tmp);
			SWAP_INT(x1, x3, tmp);
		}
		if (y2 > y3) {
			SWAP_INT(y2, y3, tmp);
			SWAP_INT(x2, x3, tmp);
		}
	}/*sort*/

	tjs_int dx12 = x2 - x1; // X̕
	tjs_int dy12 = y2 - y1; // Y̕
	tjs_int dx13 = x3 - x1; // X̕
	tjs_int dy13 = y3 - y1; // Y̕
	tjs_int dx23 = x3 - x2; // X̕
	tjs_int dy23 = y3 - y2; // Y̕

	const tjs_int G = 1024;
	tjs_int xa12 = x1; // x1 -> x2
	tjs_int ya12 = y1; // y1 -> y2
	tjs_int xa13 = x1; // x1 -> x3
	tjs_int ya13 = y1; // y1 -> y3

	tjs_int E12 = 0;
	tjs_int E13 = 0;
	tjs_int E23 = 0;

	tjs_int D12 = (dy12 != 0) ? (dx12 * G / dy12) : 0;
	tjs_int D13 = (dy13 != 0) ? (dx13 * G / dy13) : 0;
	tjs_int D23 = (dy23 != 0) ? (dx23 * G / dy23) : 0;

	tjs_int xx;
	tjs_int dxx;

	// 㔼
	for (tjs_int i = 0; i < dy12; i++) {
		tjs_int trv;

		xx = xa13;
		dxx = xa12 - xa13;
		if (dxx < 0) {
			xx = xa12;
			dxx = -dxx;
		}
		trv = Layer_drawHorizontalLineImpl(layer, xx, ya13, dxx, col, opa);
		F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)

		E12 += D12;
		xa12 = x1 + E12 / G;
		ya12++;

		E13 += D13;
		xa13 = x1 + E13 / G;
		ya13++;
	}

	if (rv < 0) return rv;

	if (dy12 < 1) xa12 = x2;

	// 
	tjs_int xa23 = xa12; // x2 -> x3
	tjs_int ya23 = ya12; // y2 -> y3
	for (tjs_int i = 0; i <= dy23; i++) {
		tjs_int trv;

		xx = xa13;
		dxx = xa23 - xa13;
		if (dxx < 0) {
			xx = xa23;
			dxx = -dxx;
		}
		trv = Layer_drawHorizontalLineImpl(layer, xx, ya13, dxx, col, opa);
		F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)

		E13 += D13;
		xa13 = x1 + E13 / G;
		ya13++;

		E23 += D23;
		xa23 = xa12 + E23 / G;
		ya23++;
	}


	// auto update
	if (TPFAutoUpdateMode && rv > 0) {
		// sort x1 <= x2 <= x3
		tjs_int tmp;
		if (x1 > x2) {
			SWAP_INT(x1, x2, tmp);
		}
		if (x1 > x3) {
			SWAP_INT(x1, x3, tmp);
		}
		if (x2 > x3) {
			SWAP_INT(x2, x3, tmp);
		}

		tjs_int w = x3 - x1 + 1;
		tjs_int h = y3 - y1 + 1;

		Layer_FuncCall_update(layer, x1, y1, w, h);
	}

	return rv;
}


// pgbNȐ
tjs_int TPFUNCCALL Layer_drawParametricCurveImpl(
	LayerInfo * layer,
	ParametricCurveTracer * curve,
	tjs_uint32 col,
	tjs_int opa)
{
	if (!curve->isActive()) return -1;

	tjs_int rv = 0;

	tjs_int numPoints = curve->getNumPoints();
	tjs_int accuracy  = curve->getAccuracy();

	tjs_int sx = 0, sy = 0;
	tjs_int dx = 0, dy = 0;

	curve->getCoord(numPoints - 2, accuracy, dx, dy);

	for (tjs_int index = numPoints - 2; index >= 0; --index) {
		for (tjs_int subindex = accuracy - 1; subindex >= 0; --subindex) {
			curve->getCoord(index, subindex, sx, sy);
			tjs_int diffx = 0;
			tjs_int diffy = 0;
			// 1sNZ̍UhF
			// dˏĂ܂ƁA`掞ɂ҂肩̂ŁB
			if (sx < dx) diffx = -1;  if (sx > dx) diffx = 1;
			if (sy < dy) diffy = -1;  if (sy > dy) diffy = 1;
			tjs_int trv = Layer_drawLineImpl(layer, sx, sy, dx + diffx, dy + diffy, col, opa);
			F__CHECK_HL_IMPL_RESULT_RETURN(trv, rv);
			dx = sx;
			dy = sy;
		}
	}

	return rv;
}


